/*

//////////////////////
// MOHAA DOORS GSC //
// BY: Bdbodger   //
///////////////////

=========================================================================================================================================================


	Triggers have a targetname of door_trig and key: script_noteworthy value: rot , rot_nouse , slide , slide_nouse or trap . You may use what ever type of trigger you need or

	as many trigger as you want but for door blocking do not use a trigger use script will check if the player is useing the use key

	trigger names with _nouse at the end ( rotateing or slide ) will open without the player needing to use the use key .

	( does not apply to trap door so useing a trigger multiple or trigger radius will make door open without the player useing the use key ).

=========================================================================================================================================================

	==========================
	Creating a rotateing door
	==========================

	Create a trigger multiple with targetname door_trig and give it a key: script_noteworthy value: rot

	Deselect everything and create a brush for the door and give it a texture .

	Deselect everything and create a brush for the hinge and give it the origin texture . Place it where you want the door hinge to be .

	Select the door brush and the origin brush , make them a script_brushmodel and give them a key: script_noteworthy value: metal or wood . 

	You can if you wish give the door a targetname it can be used later to lock or unlock the door from script .

	You can give the door a key: script_delay and value: ?? set the value to the amount of time in seconds you want the door to remain open 

	the default time for a rotateing door is 1 . You can set a key:script_turningdir and value of either left or right to make a door(s)

	that only opens one way the default is for the door(s) to always open away from the player . Applies to rotateing doors only .

	( double doors must have one door's script_turningdir set to left the other to right if you are useing script_turningdir)

	Deselect everything then select the trigger then the door and press w so that the trigger targets the door .

	Deselect everything and create a script_origin and place it at the far edge of the door away from the hinge .

	Deselect everything again select the door then the script_origin and press w so that the door targets the script_origin .

	Place the trigger so that it covers both sides of the door. Make sure it is large enough so that the player can trigger it without getting

	too close to the door . Done . ( you must use a trigger multiple or trigger radius with this type of door for blocking to work ) .

	=================================================
	Creating double rotateing doors
	=================================================

	To create double doors do the same as above only create two doors you still only need to create one trigger and one script_origin .

	You can if you wish give the doors a targetname it can be used later to lock or unlock the doors from script ( must be the same targetname) .

	When you select the trigger have it target the first door and then have it target the second door ( must be the same targetname).

	(if doors already have the same targetname targeting the first door should also target the second door ) .

	Place the script_origin where the doors meet in the center and have each door target the script_origin by selecting each door first 

	then the script_origin and pressing w . Place the trigger so that it covers both sides of the door. Make sure it is large enough so that 

	the player can trigger it without getting too close to the door . Done .

	[door_trig]-->[door(s)]-->[script_origin]

=========================================================================================================================================================

	==========================
	Creating a slideing door
	==========================

	Create a trigger use or trigger multiple with targetname door_trig and give it a key: script_noteworthy value: slide

 	( if you make a trigger use you must make two one for each side of the door block trigger will no longer work COD bug !!!)

	Deselect everything and create a brush for the door and give it a texture .

	Deselect everything , create a brush and give it the origin texture and place it the edge of the door that you want the door to travel towards.

	Select the door brush and the origin brush , make them a script_brushmodel and give them a key: script_noteworthy value: metal or wood . 

	You can if you wish give the door a targetname it can be used later to lock or unlock the door from script .

	You can give the door a key: script_delay and value: ?? set the value to the amount of time in seconds you want the door to remain open 

	the default time for a slideing door is 2 .

	Deselect everything then select the trigger then the door and press w so that the trigger targets the door .

	Deselect everything and create two script_origins and place the first one at the edge of the door where the origin brush is .

	then place the second on at the far edge of the door away from the origin brush .

	Deselect everything and then select the door and then the first script_origin and press w so that the door targets the first script_origin .

	Select the second script_origin with the first script_origin still selected and press w again so that the first script_origin targets the second .

	The distance and angle the door will slide is the distance and angle that the second script_origin is from the first script_origin .

	To increase or decrease the distance the door travels move the second script origin closer or farther away from the first script_origin .

	The door does not follow the script_origins like a path it travels form it's origin at the same angle and distance that the first script_origin

	is from the second . The direction of travel is from the second script_origin toward the first script_origin . Create a second trigger multiple and

	have the second script origin target it . This trigger acts as a blocked door trigger so make it fit inside of the door opening .

	=======================================
	Creating a door that slides up and down
	=======================================

	Do the same as above only put the origin brush at either the top or bottom of the door and the first script_origin at the top and the second one

	at the bottom to go up or the other way around to go down . As I said above the door does not follow the script_origins like a path it travels 

	form it's origin at the same angle and distance that the first script_origin is from the second script_origin .

	The direction of travel is from the second script_origin toward the first script_origin .

	[door_trig]-->[door]-->[first script_origin]-->[second script_origin]-->[door block trigger]

=========================================================================================================================================================

	==========================
	Creating a trap door
	==========================

	Create a trigger multiple , trigger radius or trigger use ( if you make a trigger use you must make two one for each side of the door )

	with targetname door_trig and give it a key: script_noteworthy value: trap

	If you use a trigger use you can give the trigger a key: setcursorhint and value: HINT_NONE so that the trigger does not show an icon .

	Deselect everything and create a brush for the door and give it a texture .

	Deselect everything and create a brush for the hinge and give it the origin texture . Place it where you want the door hinge to be .

	Select the door brush and the origin brush , make them a script_brushmodel and give them a key: script_noteworthy value: metal or wood . 

	You can if you wish give the door a targetname it can be used later to lock or unlock the door from script .

	You can give the door a key: script_delay and value: ?? set the value to the amount of time in seconds you want the door to remain open 

	the default time for a trap door is 3 .

	Deselect everything then select the trigger then the door and press w so that the trigger targets the door .

	Deselect everything and create two script_origins and place one at the far edge of the door away from the hinge .

	Place the other one above the door to have it open up or below the door to have it open down .

	Deselect everything again select the door then the first script_origin and press w so that the door targets the script_origin .

	The door gets it's yaw angle from the angle between the its origin and the first script_origin , line up the targeting arrow to the yaw angle you need .

	Select the second script_origin with the first script_origin still selected and press w again so that the first script_origin targets the second .

	Place the trigger so that it covers both sides of the door. Done .

	[door_trig]-->[door]-->[first script_origin]-->[second script_origin] ( no door block checking on trap doors)

=========================================================================================================================================================

	=================================================
	Doors can be locked or unlocked by script.
	To lock or unlock a door from script you need to add a line to your script. Here is an example of that.
	=================================================

	maps\mp\_mohaa_doors::lock_door("doorname"); // doorname is the targetname you gave the door
 
	maps\mp\_mohaa_doors::unlock_door("doorname"); // doorname is the targetname you gave the door

	Doors can be given a script_noteworthy2 of locked . Locked doors have a locked door sound .

	Locking a door from script sets it's script_noteworthy2 to locked or undefined .

=========================================================================================================================================================

*/

main()
{
	door_trigs = getentarray("door_trig","targetname");

	for(i = 0; i < door_trigs.size; i++)
	{
		if(! isdefined (door_trigs[i].script_noteworthy))

			door_trigs[i].script_noteworthy = "rot";

		switch (door_trigs[i].script_noteworthy)
		{
			case "rot":
			case "rot_nouse":

				 door_trigs[i] thread rot_door_think();break;

			case "slide":
			case "slide_nouse":

				 door_trigs[i] thread slide_door_think();break;

			case "trap":

				 door_trigs[i] thread trap_door_think();break;
		}
	}
}

//--------------------------------------------------------------------------------------------------------------

rot_door_think()
{

	while(1)
	{
		self waittill ("trigger",other);

		door = getentarray(self.target,"targetname");

		for(i=0;i<door.size;i++)
		{
			if(! isdefined(door[i].script_start) || door[i].script_start == false)
			{
				if(self.script_noteworthy == "rot_nouse")

					self thread open_door(door[i],other);
				else
				{
					if(other useButtonPressed())
						self thread open_door(door[i],other);
				}
			}

			self thread detect_touch(door[i],other);
		}
	}
}

//--------------------------------------------------------------------------------------------------------------

open_door(door,other)
{

	door.script_start = true;

	door_yaw = undefined;

	open_sound1 = undefined;
	open_sound2 = undefined;
	stop_sound = undefined;
	close_sound = undefined;

	if(isdefined (door.script_noteworthy2) && (door.script_noteworthy2 == "locked"))
	{
		
		if(! isdefined (door.script_noteworthy))
			door.script_noteworthy = "wood";

		if(door.script_noteworthy == "wood")
			door playsound ("wood_door_locked");
		else
			door playsound ("metal_door_locked");

		door.script_start = false;
	}
	else
	{

		if(! isdefined (door.script_noteworthy))
			door.script_noteworthy = "wood";

			switch(door.script_noteworthy)
			{
				case "wood":
						open_sound1 = "wood_door_open";
						open_sound2 = "wood_door_move";
						stop_sound = "wood_door_open_stop";
						close_sound = "wood_door_close_stop";
						break;
				case "metal":
						open_sound1 = "metal_door_open";
						open_sound2 = "metal_door_open";
						stop_sound = "metal_door_close";
						close_sound = "metal_door_close";
						break;
			}

		if(! isdefined(door.script_delay))
			door.script_delay = 1;

		open_move_timer = door.script_delay;

		if(isdefined(door.script_turningdir))
		{
			if(door.script_turningdir == "left")
				door_yaw = - 90;

			if(door.script_turningdir == "right")
				door_yaw = 90;
		}
		else
		{
			script_org = getent(door.target,"targetname");

			ang1 = vectortoangles(door.origin - script_org.origin);

			ang2 = vectortoangles(door.origin - other.origin);

			if(ang1[1] > ang2[1])
			{
				if((ang1[1] - ang2[1]) > 180)
					door_yaw = - 90;
				else
					door_yaw = 90;
			}
			else
			{
				if((ang2[1] - ang1[1]) > 180)
					door_yaw =  90;
				else
					door_yaw = -90;
			}
		}

		if(! isdefined (door.script_noteworthy))

			door.script_noteworthy = "wood";

		door.yawto = door_yaw;

		move_timer = 2;

		yaw_angle = -1;

		while(1)
		{
			door playsound (open_sound1); //("wood_door_open");

			start_time =  gettime();

			if(move_timer < .01)
				move_timer = .01;

			door rotateto ((0,door_yaw,0), move_timer, 0, 0);

			door waittill ("rotatedone");

			angles = door.angles;

			door rotateto (angles,.01,0,0);// stop the door maybe a touch

			end_time = gettime();

			time =  ((end_time - start_time)/ 1000);

			move_timer -= time;

			if(move_timer < .01)
				move_timer = .01;

			yaw_angle = angles[1];

			if(door_yaw < 0)
				yaw_angle -= 360; // door angles always positive so convert to negative number

			if(yaw_angle == door_yaw) // check to see door is all the way open
				break;
			else
				door waittill("notouch"); // rotatedone sent by touch thread so wait
		}

		door playsound (stop_sound); //("wood_door_open_stop");

		door.yawto *= -1;

		wait open_move_timer;

		move_timer = 2;

		while(1)
		{
			door playsound (open_sound2); //("wood_door_move");

			start_time =  gettime();

			door rotateto ((0,0,0), move_timer, 0, 0);

			door waittill ("rotatedone");

			angles = door.angles;

			door rotateto (angles,.01,0,0);// stop the door maybe a touch

			end_time = gettime();

			time =  ((end_time - start_time)/ 1000);

			move_timer -= time;

			if(move_timer < .01)
				move_timer = .01;

			yaw_angle = angles[1];

			if(yaw_angle <= 0) // check to see door is all the way closed
				break;
			else
				door waittill("notouch"); // rotatedone sent by touch thread so wait
		}

		door playsound (close_sound);

		door.yawto = undefined;

		door notify("closed");

		door.script_start = false;
	}
}




//--------------------------------------------------------------------------------------------------------------

slide_door_think()
{

	while(1)
	{
		self waittill ("trigger",other);

		door = getentarray(self.target,"targetname");

		for(i=0;i<door.size;i++)
		{
			if(! isdefined(door[i].script_start) || door[i].script_start == false)
			{
				if(self.script_noteworthy == "slide_nouse")

					self thread open_slide_door(door[i]);
				else
				{
					if(other useButtonPressed())

						self thread open_slide_door(door[i]);
				}
			}

				self thread detect_slide_touch(door[i],other);
		}

	}
}

//--------------------------------------------------------------------------------------------------------------

open_slide_door(door)
{

	door.script_start = true;

	open_sound1 = undefined;
	stop_sound = undefined;
	close_sound = undefined;

	if(isdefined (door.script_noteworthy2) && (door.script_noteworthy2 == "locked"))
	{
		
		if(! isdefined (door.script_noteworthy))
			door.script_noteworthy = "wood";

		if(door.script_noteworthy == "wood")
			door playsound ("wood_door_locked");
		else
			door playsound ("metal_door_locked");

		door.script_start = false;
	}
	else
	{


		if(! isdefined (door.script_noteworthy))

			door.script_noteworthy = "wood";

			switch(door.script_noteworthy)
			{
				case "wood":
						open_sound1 = "wood_sliding_door";
						stop_sound = "wood_door_open_stop";
						close_sound = "wood_door_close_stop";
						break;
				case "metal":
						open_sound1 = "metal_door_sliding_open";
						stop_sound = "metal_door_sliding_close";
						close_sound = "metal_door_close";
						break;
			}

		if(! isdefined(door.script_delay))
			door.script_delay = 2;

		open_move_timer = door.script_delay;

		script_org1 = getent(door.target,"targetname");

		script_org2 = getent(script_org1.target,"targetname");

		vec = (script_org1.origin - script_org2.origin);

		pos1 = door.origin;

		pos2 = (door.origin + vec);

		move_timer = 3;

		while(1)
		{
			start_time =  gettime();

			if(move_timer < .01)
				move_timer = .01;

			door playsound (open_sound1);

			door moveto(pos2, move_timer, 0, 0);

			door waittill ("movedone");

			door moveto(door.origin,.01,0,0);

			end_time = gettime();

			time =  ((end_time - start_time)/ 1000);

			move_timer -= time;

			if(move_timer < .01)
				move_timer = .01;

			if(door.origin == pos2)
				break;
			else
				door waittill("notouch"); // rotatedone sent by touch thread so wait

		}

		door playsound (stop_sound);

		wait open_move_timer;

		move_timer = 3;

		while(1)
		{
			start_time =  gettime();

			if(move_timer < .01)
				move_timer = .01;

			door playsound (open_sound1);

			door moveto(pos1, move_timer, 0, 0);

			door waittill ("movedone");

			door moveto(door.origin,.01,0,0);

			end_time = gettime();

			time =  ((end_time - start_time)/ 1000);

			move_timer -= time;

			if(move_timer < .01)
				move_timer = .01;

			if(door.origin == pos1)
				break;
			else
				door waittill("notouch"); // rotatedone sent by touch thread so wait

		}

		door notify("closed");

		door.script_start = false;
	}
		
}

//--------------------------------------------------------------------------------------------------------------

trap_door_think()
{
	while(1)
	{
		self waittill ("trigger");

		door = getentarray(self.target,"targetname");

		for(i=0;i<door.size;i++)
		{
			if(! isdefined(door[i].script_start) || door[i].script_start == false)

				self thread open_trap_door(door[i]);
		}

	}
}

//--------------------------------------------------------------------------------------------------------------

open_trap_door(door)
{
	door.script_start = true;

	open_sound1 = undefined;
	open_sound2 = undefined;
	stop_sound = undefined;
	close_sound = undefined;

	if(isdefined (door.script_noteworthy2) && (door.script_noteworthy2 == "locked"))
	{
		
		if(! isdefined (door.script_noteworthy))
			door.script_noteworthy = "wood";

		if(door.script_noteworthy == "wood")
			door playsound ("wood_door_locked");
		else
			door playsound ("metal_door_locked");

		door.script_start = false;
	}
	else
	{

		if(! isdefined (door.script_noteworthy))

			door.script_noteworthy = "wood";

			switch(door.script_noteworthy)
			{
				case "wood":
						open_sound1 = "wood_door_open";
						open_sound2 = "wood_door_move";
						stop_sound = "wood_door_open_stop";
						close_sound = "wood_door_close_stop";
						break;
				case "metal":
						open_sound1 = "metal_door_open";
						open_sound2 = "metal_door_open";
						stop_sound = "metal_door_close";
						close_sound = "metal_door_close";
						break;
			}

		if(! isdefined(door.script_delay))
			door.script_delay = 3;

		open_move_timer = door.script_delay;

		script_org1 = getent(door.target,"targetname");

		script_org2 = getent(script_org1.target,"targetname");

		ang1 = vectortoangles(door.origin - script_org1.origin);

		ang1 = (0,ang1[1],0);

		org_origin1 = script_org1.origin;

		org_origin2 = script_org2.origin;

		script_org1.origin = door.origin;

		script_org1.angles = ang1;

		door linkto(script_org1);

		if(org_origin1[2] < org_origin2[2])
			new_ang = (ang1[0] + 90,ang1[1],ang1[2]);
		else
			new_ang = (ang1[0] - 90,ang1[1],ang1[2]);

			door playsound (open_sound1);
			script_org1 rotateto(new_ang, 1, 0, 0);
			script_org1 waittill ("rotatedone");
			door playsound (stop_sound);

			wait open_move_timer; //.5;

			door playsound (open_sound2);
			script_org1 rotateto(ang1, 1, 0, 0);
			script_org1 waittill ("rotatedone");
			door playsound (close_sound);
		//}

		door unlink();

		script_org1.origin = org_origin1;

		door.script_start = false;
	}
}

//--------------------------------------------------------------------------------------------------------------

trigger_touch(door,other) // hack not sure if it is even helping occasional door freeze door will respond again when triggered anyway .
{
	door endon("closed");

	while(other istouching(self))
	{
		wait .01;
	}

	door notify("notouch");

	other.trigger_touch = undefined;
}

//--------------------------------------------------------------------------------------------------------------

lock_door(doorname)
{
	doors = getentarray(doorname,"targetname");

	for(i = 0; i < doors.size; i++)
	{
			doors[i].script_noteworthy2 = "locked";
	}
}

//--------------------------------------------------------------------------------------------------------------

unlock_door(doorname)
{
	doors = getentarray(doorname,"targetname");

	for(i = 0; i < doors.size; i++)
	{
			doors[i].script_noteworthy2 = undefined;
	}
}

//--------------------------------------------------------------------------------------------------------------

detect_slide_touch(door,other)
{

	door endon("closed");

	ent1 = getent(door.target,"targetname"); // script origin 1

	ent2 = getent(ent1.target,"targetname"); // script origin 2

	if(isdefined(ent2.target))
	{
		ent3 = getent(ent2.target,"targetname");  // block trigger

		if(other istouching(ent3))

			door notify("movedone");
		else
			door notify("notouch");
	}
	else
		door notify("notouch");
}
//--------------------------------------------------------------------------------------------------------------

detect_touch(door,other)
{

	door endon("closed");

	if(!isdefined(other.trigger_touch))
	{
		other.trigger_touch = 1;
		self thread trigger_touch(door,other);
	}

	if(isdefined(door.yawto))
	{
		script_org = getent(door.target,"targetname");

		door_org = door.origin;

		sc_org = script_org.origin;

		otr_org = other.origin;

		dist1 = length((door_org[0],door_org[1],1) - (sc_org[0],sc_org[1],1));

		dist2 = length((door_org[0],door_org[1],1) - (otr_org[0],otr_org[1],1));

		if(dist1 > (dist2 - 32))
		{

		// destination yaw ---------------------

			ang1 = vectortoangles(door_org - sc_org); // start yaw angle

			start_yaw = ang1[1];

			if(start_yaw > 270)
				start_yaw -= 90;

			if(start_yaw < 90)
				start_yaw += 90;

			dest_yaw = start_yaw + door.yawto;

		// door yaw ---------------------

			door_ang = door.angles;

			///////////////////////////////////////////////////////////////////
			// angles always positive so 0 - 10 rotation will give you 350/////
			///////////////////////////////////////////////////////////////////

			if(door_ang[1] > 180)
			{
				door_rot = (360 - door_ang[1]);

				door_rot *= -1;
			}
			else
			{
				door_rot = door_ang[1];
			}

			door_yaw = start_yaw + door_rot;

		// player yaw ---------------------

			ang4 = vectortoangles(door_org - otr_org);

			player_yaw = ang4[1];

			if(ang1[1] > 270)
				player_yaw -= 90;

			if(ang1[1] < 90)
				player_yaw += 90;

		// block check ---------------------

			if((player_yaw < dest_yaw && player_yaw > door_yaw)||(player_yaw > dest_yaw && player_yaw < door_yaw))
			{
				door notify("rotatedone");

				//string = ("start yaw" + start_yaw + "dest_yaw " + dest_yaw + " door_yaw" + door_yaw + " player_yaw " + player_yaw );

				//iprintln(string);

			}
			else
				door notify("notouch");

		}
		else
			door notify("notouch");

	}
}
